#ifndef JJVV_3H
#pragma once
#define JJVV_3H
#include <jjvv_1.h>
#include <jjvv_2.h>

//PIC 11/05/2014

class JJVV_3 : public JJVV_2
{
public:
	
	JJVV_3();
	~JJVV_3();


	void SetRiderName(char *);
	std::string GetRiderName();

	void SetRiderEmail (char *); //"Caridad.I.Gonzalez@noaa.gov";
	std::string GetRiderEmail ();

	void SetRiderInst(char *);// = "AOML PHoD";
	std::string GetRiderInst();

	void SetRiderPhoneNo(char *);// ="305-361-4322";
	std::string GetRiderPhoneNo();

	bool SetAgencyOwner(int);
	AgencyTable GetAgencyOwner(int);

    std::string NODCform(unsigned long *CRC); // Pass the GTS CRC if Necessary
	std::string NODCformMETA_3();

	bool SetXBTLauncherType(int);
	CodeTable GetXBTLauncherType();

	void SetRecorderSerialNo(char *);
	std::string GetRecorderSerialNo();

	void SetXBTRecorderManufDate(tm);
	tm GetXBTRecorderManufDate();

	void SetXBTManufDate(tm);
	tm GetXBTManufDate();

	RetMess BuildBinMess(int);

	bool DecodeBinMess(RetMess*);

//	void DecodeRiderBlocks(int);

	unsigned long ComputeMessCRC(bool *);


	/*	void SetTransectNo(int);
	void SetSOOPLine(char *);
	void SetLaunchHeight(float);
	void SetProbeSerial(int);
	int GetProbeSerial();
	float GetShipSpeed();
	int GetShipDir();
	int GetSeqNo();
	int GetTransectNo();
	std::string GetSOOPLine();
	float GetLaunchHeight();
//	bool DecodeBinMess(RetMess *);
    std::string NODCform(unsigned long *CRC); // Pass the GTS CRC if Necessary
	std::string NODCformMETA_2();
	bool DecodeElements(int start, int No_To_Decode, RetMess *InMess, int *BitPos);
	bool DecodeBinMess(RetMess *);
*/
protected:
	FXY1036 AgencyOwner;
	FXY22178 XBTLauncherType;
	FXY2171 XBTRecorderSerial;
	FXY4001 XBT_Rec_Manuf_Year;
	FXY4002 XBT_Rec_Manuf_Month;
	FXY4003 XBT_Rec_Manuf_Day;
	FXY4001 XBT_Probe_Manuf_Year;
	FXY4002 XBT_Probe_Manuf_Month;
	FXY4003 XBT_Probe_Manuf_Day;
	FXY31001B No_RiderBlocks;
	FXY31001B No_RiderEmailBlocks;
	FXY31001B No_RiderPhoneBlocks;
	FXY31001B No_RiderInstBlocks;


	int NoRiderCommentBlocks;

// rider name follows XBT data
// Rider Inst
// Rider Email
// Rider Phone

/*	FXY205030 Ship_Rider;
	FXY205030 Rider_Inst;
	FXY205030 Rider_Email;
	FXY205030 Rider_Telephone_No;
*/
	bool DecodeType1;
	std::string RiderName;
	std::string RiderEmail;
	std::string RiderInst;
	std::string RiderPhoneNo;

private:
	void ComputeNoCommentBlocks();
//	bool ExcludeElement(int Elno);
//	void ResetProbeOnVect();
};

#endif
