//#include <string>
#include <FM94Elem.h>
#include <SEASOB_1.h>
#include <jjvv_1.h>
#include <jjvv_2.h>
#include <jjvv_3.h>
#include <time.h>
#include <iostream>
#include <fstream>
using namespace std;

std::string format(const char *fmt, ...); 
//std::string format1(const char *format, int var );
//std::string format1(const char *format, float var);
//std::string format1(const char *format, char *var);
//std::string format1(const char *format, std::string var);

int main()
{
	void *pvoid;


	FXY22178 XBT_Type;
	CodeTable xbt_text = XBT_Type.GetTableElem(30);
	CodeTable xbt_launch2 = XBT_Type.GetTableElemAt(12);
	int xbt_size = XBT_Type.GetNoElems();
	xbt_launch2 = XBT_Type.GetTableElemAt(14);
	bool valid = XBT_Type.ValidValue(29);
	FM94Value xxx = XBT_Type.GetValue();

	FXY1036 Agency;

	AgencyTable Ag1 = Agency.GetTableElem(840004);
	AgencyTable Ag2 = Agency.GetTableElemAt(12);
	int Agency_size = Agency.GetNoElems();
	Ag2 = Agency.GetTableElemAt(14);
	valid = Agency.ValidValue(29);
	Agency.SetValue(840003);
	FM94Value aval = Agency.GetValue();

	JJVV_3 XBT3_1;
	unsigned long CRC = -1;

	JJVV_2 XBT2;
	RetMess data;

	JJVV_3 XBT3;

	int xyz = XBT2.GetDataType();

	ifstream infile;
	ofstream ofile;
//TEST_20131031180813_N04_XBT.bin
	infile.open("h:\\badfile\\053BF0se.bin",ios::in|ios::binary|ios::ate); // open at end of file
//	infile.open("h:\\xbttest\\TEST_20131031180813_N04_XBT.bin",ios::in|ios::binary|ios::ate); // open at end of file
//	infile.open("h:\\xbttest\\TEST_20131104221532_N01_XBT.bin",ios::in|ios::binary|ios::ate); // open at end of file
	if(infile.is_open())
	{
		int length = infile.tellg();
		data.size = length;
		data.Mess = new char [length];
		infile.seekg(0);
		infile.read (data.Mess, length);
		infile.close();
	}

	XBT2.DecodeBinMess(&data);

//	XBT3.SetMessType(XBT2.GetMessType());
	XBT3.SetWMO_ID((char *) XBT2.GetWMO_ID().c_str());
	XBT3.SetObtime(XBT2.GetObTime());
	XBT3.SetLat(XBT2.GetLat());
	XBT3.SetLon(XBT2.GetLon());
	XBT3.SetSeqNo(XBT2.GetSeqNo());
	XBT3.SetLloyds(XBT2.GetLloyds());\
	XBT3.SetShipName((char *)XBT2.GetShipName().c_str());
	XBT3.SetSEASVersion(XBT2.GetSEASVersion());
//	XBT3.SetShipDir(XBT2.GetShipDir());
	XBT3.SetShipDir(210);
//	XBT3.SetShipSpeed(XBT2.GetShipSpeed());
	XBT3.SetShipSpeed(20.25);
	XBT3.SetUniqueTag(XBT2.GetUniqueTag());
	unsigned long oldcrc = XBT2.GetUniqueTag(); 
	XBT3.SetInstType(XBT2.GetInstType());
	XBT3.SetDryBulbTemp(15.8);
	XBT3.SetLaunchHeight(25.68);
	XBT3.SetSeqNo(10);
	XBT3.SetWindDir(240);
	XBT3.SetWindSpeed(15.3);
	XBT3.SetTypeWindInst(3);
	XBT3.SetTransectNo(23);

	string spl = XBT2.GetSOOPLine();
	XBT3.SetSOOPLine("AX07");
//	XBT3.SetSOOPLine((char*)XBT2.GetSOOPLine().c_str());
	XBT3.SetTotalWaterDepth(1890);
	XBT3.SetProbeSerial(3454321);//XBT2.GetProbeSerial());

	XBT3.SetCurrentDir(221);
	XBT3.SetCurrentSpeed(15.34);
	XBT3.SetCurrMeasMeth(1);

	XBT3.SetRecorderType(XBT2.GetRecorderType());

	XBT3.SetRiderName("Ibis Gonzalez");
	XBT3.SetRiderEmail("Caridad.I.Gonzalez@noaa.gov");
//	XBT3.SetRiderEmail("");
	XBT3.SetRiderInst("AOML PHoD");
	XBT3.SetRiderPhoneNo("305-361-4322");
	XBT3.SetXBTLauncherType(30);
	XBT3.SetRecorderSerialNo("34567898");

	tm man_date;
	man_date.tm_year=104; // 2004 - 1900
	man_date.tm_mon = 7;  // August
	man_date.tm_mday = 25; // 25th

	XBT3.SetXBTRecorderManufDate(man_date);

	man_date.tm_year=95; // 1995 - 1900
	man_date.tm_mon = 3;  // April
	man_date.tm_mday = 15; // 15th

	XBT3.SetXBTManufDate(man_date);

	bool test  = XBT3.SetAgencyOwner(840001);
	AgencyTable Ag = XBT3.GetAgencyOwner(840001);
	int nop =  XBT2.GetNoOfPoints();


	for(int i=0; i< nop;i++)
	{
		float newtemp=XBT2.GetRawTempAt(i);
		XBT3.AddNewTemp(newtemp);
	}

/*	XBT2.ComputeInflectionPoints();
	XBT2.CompOneMeterValues();
	XBT2.CleanUpRawData();
	XBT2.ComputeTailDepth();*/

	XBT3.ComputeInflectionPoints();
	XBT3.CompOneMeterValues();
	XBT3.CleanUpRawData();
	XBT3.ComputeTailDepth();

	string xx;
//	xx = XBT2.NODCform(&CRC);

/*	ofile.open("h:\\badfile\\zcdj6NDCxbt2.NDC",ios::out|ios::binary); // open at end of file
	if(ofile.is_open())
	{
		ofile.write(xx.c_str(),xx.length());
		ofile.close();
	}
*/
	//
		xx="";
		xx = XBT3.NODCform(&CRC);

	ofile.open("h:\\badfile\\zcdj6NDCxbt3.NDC",ios::out|ios::binary); // open at end of file
	if(ofile.is_open())
	{
		ofile.write(xx.c_str(),xx.length());
		ofile.close();
	}

	int datat = XBT2.GetDataType();
	int datat1 = XBT3.GetDataType();


	string bulletin = XBT2.BuildJJVVMess(1);
	ofile.open("h:\\badfile\\xbtJJVV_2.txt",ios::out|ios::binary); // open at end of file
	if(ofile.is_open())
	{
		ofile.write(bulletin.c_str(),bulletin.size());
		ofile.close();
	}

	string bulletin1 = XBT3.BuildJJVVMess(1);
	ofile.open("h:\\badfile\\xbtJJVV_3.txt",ios::out|ios::binary); // open at end of file
	if(ofile.is_open())
	{
		ofile.write(bulletin1.c_str(),bulletin1.size());
		ofile.close();
	}

//	int num_of_blocks = XBT3.ComputeNoCommentBlocks();

	RetMess newmess1;
	bool crcvalid;
	unsigned long crc = XBT3.ComputeMessCRC(&crcvalid);
	XBT3.SetUniqueTag(crc);
//	newmess1 = XBT3.BuildBinMess(1);
//	crc=XBT3.CalcCRC32(newmess1.Mess,newmess1.size);
//	XBT3.SetUniqueTag(crc);

	newmess1 = XBT3.BuildBinMess(1);
	ofile.open("c:\\amverseas\\zcdj6A.bin",ios::out|ios::binary); // open at end of file
	if(ofile.is_open())
	{
		ofile.write(newmess1.Mess,newmess1.size);
		ofile.close();
	}

	infile.open("c:\\amverseas\\zcdj6A.bin",ios::in|ios::binary|ios::ate); // open at end of file
	if(infile.is_open())
	{
		int length = infile.tellg();
		data.size = length;
		data.Mess = new char [length];
		infile.seekg(0);
		infile.read (data.Mess, length);
		infile.close();
	}

	XBT3_1.DecodeBinMess(&data);

	std::string wmoid = XBT3_1.GetWMO_ID();

	newmess1 = XBT3.BuildBinMess(2);
	ofile.open("c:\\amverseas\\zcdj6B.bin",ios::out|ios::binary); // open at end of file
	if(ofile.is_open())
	{
		ofile.write(newmess1.Mess,newmess1.size);
		ofile.close();
	}


	newmess1 = XBT3.BuildBinMess(3);
	ofile.open("c:\\amverseas\\zcdj6C_1.bin",ios::out|ios::binary); // open at end of file
	if(ofile.is_open())
	{
		ofile.write(newmess1.Mess,newmess1.size);
		ofile.close();
	}

} 