// PIC 11/05/2014


#include <FM94Elem.h>
#include <vector>
#include<string>
//#include <afxcoll.h>
//#include <afxtempl.h>
#ifndef SEASOB_H
#define SEASOB_H
#pragma once
//using namespace std;
#ifndef SEAS_ELEM_DEF
#define SEAS_ELEM_DEF
	typedef std::vector<FM94Elem *> SEASElem;
	typedef struct {int size; char* Mess;} RetMess;
#endif

class SEASOB
{
//private : char *WMO_IDret;
//	bool WMO_IDAlloc;
protected:

/** CALC_CRC32.C - Routine to calculate CRC32 for a string passed from
//                calling program. Routine to call is calc_crc32.
// Adapted from CRC tester v1.3 written by Sven Reifegerste (zorc/reflex)
// Uses the fast table algorithm.
//
// John Minaker, May 2003
// ----------------------------------------------------------------------------
//
// CRC parameters (default values are for CRC-32):

int order;
unsigned long polynom;
int direct;
unsigned long crcinit;
unsigned long crcxor;
int refin;
int refout;

// 'order' [1..32] is the CRC polynom order, counted without the leading '1' bit
// 'polynom' is the CRC polynom without leading '1' bit
// 'direct' [0,1] specifies the kind of algorithm: 1=direct, no augmented zero bits
// 'crcinit' is the initial CRC value belonging to that algorithm
// 'crcxor' is the final XOR value
// 'refin' [0,1] specifies if a data byte is reflected before processing (UART) or not
// 'refout' [0,1] specifies if the CRC will be reflected before XOR

// internal global values:*/

int order;
unsigned long polynom;
int direct;
unsigned long crcinit;
unsigned long crcxor;
int refin;
int refout;



unsigned long crcmask;
unsigned long crchighbit;
unsigned long crcinit_direct;
unsigned long crcinit_nondirect;
unsigned long crctab[256];


	FXY1011 WMO_ID;
	FXY48211 Old_Mess_Type;
	FXY48216 New_Mess_Type;
	FXY5001 Lat;
	FXY6001 Lon;
	FXY4001 Year;
	FXY4002 Month;
	FXY4003 Day;
	FXY4004 Hour;
	FXY4005 Minute;
	int SEASOBSize;
	int No_SEASOBS_Elements;
	int OBGenSize;
	int MessSize;

//	FXY22067 F;

	SEASElem SEAS_Elem;
protected :
		void SetMessType(int );
		int ComputeMessSize();
		unsigned long reflect (unsigned long, int );
		void generate_crc_table();
		unsigned long crctablefast (unsigned char*, unsigned long );

public : SEASOB();
		 ~SEASOB();
		 void SetWMO_ID(char *);
		 void SetLat(double );
		 void SetLon(double);
		 void SetObtime(tm); 
		 std::string GetWMO_ID();
		double GetLat();
		double GetLon();
		tm GetObTime();
		int GetQuadrant();
		int GetMessType();
		unsigned long CalcCRC32(char *, int);
		int GetSEAS_OB_size();
};


#endif
