#ifndef JJVV_2H
#pragma once
#define JJVV_2H
#include <jjvv_1.h>

// PIC 11/05/2014

class JJVV_2 : public JJVV
{
public:
	
	JJVV_2();
	~JJVV_2();

	void SetShipSpeed(float);
	void SetShipDir(int);
	void SetSeqNo(int);
	void SetTransectNo(int);
	void SetSOOPLine(char *);
	void SetLaunchHeight(float);
	void SetProbeSerial(int);
	int GetProbeSerial();
	float GetShipSpeed();
	int GetShipDir();
	int GetSeqNo();
	int GetTransectNo();
	std::string GetSOOPLine();
	float GetLaunchHeight();
//	bool DecodeBinMess(RetMess *);
    std::string NODCform(unsigned long *); // Pass the GTS CRC if Necessary
	std::string NODCformMETA_2();
	bool DecodeElements(int start, int No_To_Decode, RetMess *InMess, int *BitPos);
	bool DecodeBinMess(RetMess *);

protected:
	FXY48300A ProbeSerial;
	FXY1012 ShipDir;
	FXY1013 ShipSpeed;
	FXY5036 TransectNo;
	FXY1080 SOOPLine;
	FXY48304 SeqNo;
	FXY48305 LaunchHeight;
	bool DecodeType1;

private:
	bool ExcludeElement(int Elno);
	void ResetProbeOnVect();
};

#endif
